SDL_PollEvent(3)

NAME
SDL_PollEvent - Poll for currently pending events.

SYNOPSIS
#include <SDL3/SDL_events.h>

bool SDL_PollEvent(SDL_Event *event);

DESCRIPTION
If event is not NULL, the next event is removed from the queue and stored in the SDL_Event structure pointed to by event.

If event is NULL, it simply returns true if there is an event in the queue, but will not remove it from the queue.

As this function may implicitly call SDL_PumpEvents(), you can only call this function in the thread that initialized the video subsystem.

SDL_PollEvent() is the favored way of receiving system events since it can be done from the main loop and does not suspend the main loop while waiting on an event to be posted.

The common practice is to fully process the event queue once every frame, usually as a first step before updating the game's state:

        while (game_is_still_running) {
            SDL_Event event;
            while (SDL_PollEvent(&event)) {  // poll until all events are handled!
                // decide what to do with this event.
            }

            // update game state, draw the current frame
        }

Note that Windows (and possibly other platforms) has a quirk about how it handles events while dragging/resizing a window, which can cause this function to block for significant amounts of time. Technical explanations and solutions are discussed on the wiki:

https://wiki.libsdl.org/SDL3/AppFreezeDuringDrag

FUNCTION PARAMETERS

event
    the SDL_Event structure to be filled with the next event from the queue, or NULL.

RETURN VALUE
Returns true if this got an event or false if there are none available.

THREAD SAFETY
This function should only be called on the main thread.

AVAILABILITY
This function is available since SDL 3.2.0.

SEE ALSO
SDL_PushEvent(3), SDL_WaitEvent(3), SDL_WaitEventTimeout(3)